package cn.jyjz.xiaoyao.framework.security.config;

import cn.jyjz.xiaoyao.common.base.config.XiaoyaoConfig;
import cn.jyjz.xiaoyao.framework.security.utils.JwtUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.annotation.Order;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.configurers.ExpressionUrlAuthorizationConfigurer;
import org.springframework.stereotype.Component;

/**
 * Created by zhangyong on 2021/3/8.
 */
@Component
@Order(Integer.MIN_VALUE)
public class AuthrizeConfigProviderImpl implements AuthrizeConfigProvider{


    @Autowired
    private XiaoyaoConfig xiaoyaoConfig;

    @Override
    public boolean config(ExpressionUrlAuthorizationConfigurer<HttpSecurity>.ExpressionInterceptUrlRegistry config) {

        JwtUtils.setSecretKey(xiaoyaoConfig);

        config.antMatchers(xiaoyaoConfig.getWebconfig().getNofilterurls().split(",")).permitAll();
        return false;
    }
}
