package cn.jyjz.xiaoyao.framework.security.service;


import cn.jyjz.xiaoyao.common.base.vo.UserToken;
import javax.servlet.http.HttpServletRequest;

/**
* 业务层
*/
public interface OnlineUserService {
	/**
	* 数据持久化
	* @param entity 要实例化的实体，不能为null
	* @return 受影响的结果数
	*/
	public int insertmodel(Object entity);

	/**
	 * 用户登录时写入
	 * @param user 当前登录用户
	 * @param token 当前用户登录token
	 * @param request 客户端请求
     * @return
     */
	public int insertmodel(UserToken user, String token, HttpServletRequest request);

	/**
	 * 通过登录账号查询登录数量
	 * @param loginname 登录账号
	 * @return 查询已经登录的数量
     */
	int selectCount(String loginname);

	/**
	 * 通过登录账号清除已经登录用户信息
	 * @param loginname 登录账号
	 * @return 查询已经登录的集合
	 */
	void removeSessionUser(String loginname);

	/**
	 * 删除缓存信息以及数据库信息
	 * @param ids
	 * @return
     */
	public boolean deleteByIdMoreAndCache(String ids);

	/**
	 * 删除所有数据
	 * @return
	 */
	public int deletall();
}
